#! /usr/bin/ruby

puts "Beginning inactive memory free routine"

vm_stat = `vm_stat`

vm_stat = vm_stat.split("\n")

page_size = vm_stat[0].match(/(\d+) bytes/)[1].to_i

pages_free = vm_stat[1].match(/(\d+)/)[1].to_i
pages_inactive = vm_stat[3].match(/(\d+)/)[1].to_i


bytes_to_read = page_size*pages_free + page_size*pages_inactive

puts "Free pages:       " + pages_free.to_s
puts "Inactive pages:   " + pages_inactive.to_s
puts "Allocating bytes: " + bytes_to_read.to_s + " (" + (bytes_to_read/(1024*1024*1024.0)).to_s + "gb)"

cmd =  "allocate " + bytes_to_read.to_s
system(cmd)

sleep(3)

vm_stat = `vm_stat`.split("\n")
pages_inactive = vm_stat[3].match(/(\d+)/)[1].to_i
puts "All done. Now there are " + pages_inactive.to_s + " inactive pages."


